<?php
/*
Plugin Name: BZPAY - WooCommerce Gateway
Plugin URI: https://github.com/migueluz/wp_bzpayGW.git
Description: Extends WooCommerce by Adding the IMIC Gateway.
Version: 2.1
Author: Miguel Uzcategui
Author URI: https://github.com/migueluz/wp_bzpayGW.git
*/

add_action( 'plugins_loaded', 'bzpay_imic_init', 0 );
function bzpay_imic_init() {
	
	if ( ! class_exists( 'WC_Payment_Gateway' ) ) return;
	
	
	include_once( 'woocommerce-bzpay-aim.php' );
   
	add_filter( 'woocommerce_payment_gateways', 'bzpay_add_imic_aim_gateway' );
	function bzpay_add_imic_aim_gateway( $methods ) {
		$methods[] = 'BZPAY_Imic_AIM';
		
		return $methods;
	}
}


add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'bzpay_imic_aim_action_links' );
function bzpay_imic_aim_action_links( $links ) {
	$plugin_links = array(
		'<a href="' . admin_url( 'admin.php?page=wc-settings&tab=checkout' ) . '">' . __( 'Settings', 'bzpay-imic-aim' ) . '</a>',
	);

	return array_merge( $plugin_links, $links );	
}
