<?php
class BZPAY_Imic_AIM extends WC_Payment_Gateway {

	
	function __construct() {

		
		$this->id = "bzpay_imic_aim";		
		$this->method_title = __( "Bzpay Payment Gateway", 'bzpay-imic-aim' );		
		$this->method_description = __( "Bzpay Payment Gateway Plug-in for WooCommerce", 'bzpay-imic-aim' );		
		$this->title = __( "Bzpay", 'bzpay-imic-aim' );		
		$this->icon = null;	
		$this->has_fields = true;
		$this->supports = array( 'default_credit_card_form' );		
		$this->init_form_fields();
		$this->init_settings();
		foreach ( $this->settings as $setting_key => $value ) {
			$this->$setting_key = $value;
			}
		add_action( 'wp_ajax_cards', 'cards' );
		if ( is_admin() ) {
			
			add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
		}		
	} 
	public function init_form_fields() {
		$this->form_fields = array(
			'enabled' => array(
				'title'		=> __( 'Enable / Disable', 'bzpay-imic-aim' ),
				'label'		=> __( 'Enable this payment gateway', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'default'	=> 'no',
			),
			'title' => array(
				'title'		=> __( 'Title', 'bzpay-imic-aim' ),
				'type'		=> 'text',
				'desc_tip'	=> __( 'Payment title the customer will see during the checkout process.', 'bzpay-imic-aim' ),
				'default'	=> __( 'Credit card', 'bzpay-imic-aim' ),
			),
			'description' => array(
				'title'		=> __( 'Description', 'bzpay-imic-aim' ),
				'type'		=> 'textarea',
				'desc_tip'	=> __( 'Payment description the customer will see during the checkout process.', 'bzpay-imic-aim' ),
				'default'	=> __( 'Pay securely using your credit card.', 'bzpay-imic-aim' ),
				'css'		=> 'max-width:350px;'
			),
			'api_login' => array(
				'title'		=> __( 'API Merchant ID', 'bzpay-imic-aim' ),
				'type'		=> 'text',
				'desc_tip'	=> __( 'This is the API Login provided by Bzpay when you signed up for an account.', 'bzpay-imic-aim' ),
			),
			'trans_key' => array(
				'title'		=> __( 'API Auth Key ', 'bzpay-imic-aim' ),
				'type'		=> 'password',
				'desc_tip'	=> __( 'This is the Transaction Key provided by Authorize.net when you signed up for an account.', 'bzpay-imic-aim' ),
			),
			'bzpayurl' => array(
				'title'		=> __( 'Url Bzpay', 'bzpay-imic-aim' ),
				'label'		=> __( 'Url Bzpay', 'bzpay-imic-aim' ),
				'type'		=> 'text',
				'description' => __( 'Ingrese la url del endpoint del servicio de Bzpay.', 'bzpay-imic-aim' ),
				
			),
			'msi' => array(
				'title'		=> __( 'MSI', 'bzpay-imic-aim' ),
				'label'		=> __( 'MSI', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'description' => __( 'Si posee activo MSI en su cuenta de comercio porfavor active esta casilla).', 'bzpay-imic-aim' ),
				'default'	=> 'no',
			),
			'threedsecure' => array(
				'title'		=> __( '3DS', 'bzpay-imic-aim' ),
				'label'		=> __( '3DS', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'description' => __( 'Desea usar el servicio 3D Security', 'bzpay-imic-aim' ),
				'default'	=> 'no',
			),
			'montouno' => array(
				'title'		=> __( 'Monto minimo para: 3 Meses', 'bzpay-imic-aim1' ),
				'type'		=> 'text',				
				'default'	=> __( '0 ', 'bzpay-imic-aim' ),
							),
			'msitresmeses' => array(
				'title'		=> __( '', 'bzpay-imic-aim' ),
				'label'		=> __( 'Ofrecer esta Promocion', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'default'	=> 'no',
			),
			'montodos' => array(
				'title'		=> __( 'Monto minimo para: 6 Meses', 'bzpay-imic-aim' ),
				'type'		=> 'text',				
				'default'	=> __( '0 ', 'bzpay-imic-aim' ),
				),
			'msiseismeses' => array(
				'title'		=> __( '', 'bzpay-imic-aim' ),
				'label'		=> __( 'Ofrecer esta Promocion', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'default'	=> 'no',
			),
			'montotres' => array(
				'title'		=> __( 'Monto minimo para: 9 Meses', 'bzpay-imic-aim' ),
				'type'		=> 'text',
				'default'	=> __( '0 ', 'bzpay-imic-aim' ),
				),
			'msinuevemeses' => array(
				'title'		=> __( '', 'bzpay-imic-aim' ),
				'label'		=> __( 'Ofrecer esta Promocion', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'default'	=> 'no',
			),
			'montocuatro' => array(
				'title'		=> __( 'Monto minimo para: 12 Meses', 'bzpay-imic-aim' ),
				'type'		=> 'text',
				'default'	=> __( '0 ', 'bzpay-imic-aim' ),
				),
			'msidocemeses' => array(
				'title'		=> __( '', 'bzpay-imic-aim' ),
				'label'		=> __( 'Ofrecer esta Promocion', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'default'	=> 'no',
			),
			'montocinco' => array(
				'title'		=> __( 'Monto minimo para: 18 Meses', 'bzpay-imic-aim' ),
				'type'		=> 'text',
				'default'	=> __( '0 ', 'bzpay-imic-aim' ),
				),
			'msidieciochomeses' => array(
				'title'		=> __( '', 'bzpay-imic-aim' ),
				'label'		=> __( 'Ofrecer esta Promocion', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'default'	=> 'no',
			),		
			
			'currency' => array(
				'title'		=> __( 'Currency', 'bzpay-imic-aim' ),
				'label'		=> __( 'Currency (If cheked the currey will be Mexican Pesos, if no the default currency is USD)', 'bzpay-imic-aim' ),
				'type'		=> 'checkbox',
				'description' => __( 'Do you want to use this gateway in Mexican Pesos (If no the default currecy will be US Dolars).', 'bzpay-imic-aim' ),
				'default'	=> 'no',
			),
			
			
		);		
	}
	
			
	public function payment_fields() {
		if ( $this->supports( 'tokenization' ) && is_checkout() ) {
			$this->tokenization_script();
			$this->saved_payment_methods();
			$this->form();
			$this->save_payment_method_checkbox();
		} else {
			$this->form();
		}
	}

	
	public function field_name( $name ) {
		return $this->supports( 'tokenization' ) ? '' : ' name="' . esc_attr( $this->id . '-' . $name ) . '" ';
	}

		public function form() {
			
		wp_enqueue_script( 'wc-credit-card-form' );
		
		global $woocommerce;
		$order = new WC_Order( $order_id );
		$cart = $woocommerce->cart;       
		$fields = array();
		$cart_total= $woocommerce->cart->total;	
		$cvc_field = '<p class="form-row form-row-last">
			<label for="' . esc_attr( $this->id ) . '-card-cvc">' . esc_html__( 'Card code', 'woocommerce' ) . '&nbsp;<span class="required">*</span></label>
			<input id="' . esc_attr( $this->id ) . '-card-cvc" class="input-text wc-credit-card-form-card-cvc" inputmode="numeric" autocomplete="off" autocorrect="no" autocapitalize="no" spellcheck="no" type="tel" maxlength="4" placeholder="' . esc_attr__( 'CVC', 'woocommerce' ) . '" ' . $this->field_name( 'card-cvc' ) . ' style="width:100px" />
		</p>';

		$default_fields = array(
			'card-name-field' => '<p class="form-row form-row-wide">
				<label for="' . esc_attr( $this->id ) . '-card-name">' . esc_html__( 'Nombre en la Tarjeta', 'woocommerce' ) . '&nbsp;<span class="required">*</span></label>
				<input id="' . esc_attr( $this->id ) . '-card-name-on-card" class="input-text wc-credit-card-form-card-name" inputmode="text"  autocorrect="no" autocapitalize="no" spellcheck="no"     type="text" placeholder="Nombre en la Tarjeta" ' . $this->field_name( 'card-name-on-card' ) . ' />
			</p>',
			'card-number-field' => '<p class="form-row form-row-wide">
				<label for="' . esc_attr( $this->id ) . '-card-number">' . esc_html__( 'Card number', 'woocommerce' ) . '&nbsp;<span class="required">*</span></label>
				<input id="' . esc_attr( $this->id ) . '-card-number" class="input-text wc-credit-card-form-card-number" inputmode="numeric" autocomplete="cc-number" autocorrect="no" autocapitalize="no" spellcheck="no" type="tel" placeholder="&bull;&bull;&bull;&bull; &bull;&bull;&bull;&bull; &bull;&bull;&bull;&bull; &bull;&bull;&bull;&bull;" ' . $this->field_name( 'card-number' ) . ' />
			</p>',
			'card-expiry-field' => '<p class="form-row form-row-first">
				<label for="' . esc_attr( $this->id ) . '-card-expiry">' . esc_html__( 'Expiry (MM/YYYY)', 'woocommerce' ) . '&nbsp;<span class="required">*</span></label>
				<input id="' . esc_attr( $this->id ) . '-card-expiry" class="input-text wc-credit-card-form-card-expiry" inputmode="numeric" autocomplete="cc-exp" autocorrect="no" autocapitalize="no" spellcheck="no" type="tel" placeholder="' . esc_attr__( 'MM / YYYY', 'woocommerce' ) . '" ' . $this->field_name( 'card-expiry' ) . ' />
			</p>',
				'card-cvc-field' => '<p class="form-row form-row-first">
				<label for="' . esc_attr( $this->id ) . '-card-cvc">' . esc_html__( 'Código de tarjeta', 'woocommerce' ) . '&nbsp;<span class="required">*</span></label>
				<input id="' . esc_attr( $this->id ) . '-card-cvc" class="input-text wc-credit-card-form-card-cvc"  inputmode="numeric" autocomplete="no" autocorrect="no" autocapitalize="no" spellcheck="no" type="password" maxlength="3" placeholder="' . esc_attr__( 'CVV', 'woocommerce' ) . '" ' . $this->field_name( 'card-cvc' ) . ' />
			</p>',
			
		);

			
		

		$fields = wp_parse_args( $fields, apply_filters( 'woocommerce_credit_card_form_fields', $default_fields, $this->id ) );
		?>

		<fieldset id="wc-<?php echo esc_attr( $this->id ); ?>-cc-form" class='wc-credit-card-form wc-payment-form'>
			<?php do_action( 'woocommerce_credit_card_form_start', $this->id ); ?>
			<?php
			foreach ( $fields as $field ) {
				echo $field; 
			}
			?>
			
			<?php do_action( 'woocommerce_credit_card_form_end', $this->id ); 
			$msi = ( $this->msi == "yes" ) ? true : false;
			
			$msi_tres_meses= ( $this->msitresmeses == "yes" ) ? true : false;
			$msi_seis_meses= ( $this->msiseismeses == "yes" ) ? true : false;
			$msi_nueve_meses= ( $this->msinuevemeses == "yes" ) ? true : false;
			$msi_doce_meses= ( $this->msidocemeses == "yes" ) ? true : false;
			$msi_dieciocho_meses= ( $this->msidieciochomeses == "yes" ) ? true : false;
			if ($msi_tres_meses == true){
			$p1 =  '<option value="3">3 Meses</option>';
			}
			if ($msi_seis_meses == true){
			$p2 =  '<option value="6">6 Meses</option>';
			}
			if ($msi_nueve_meses == true){
			$p3 =  '<option value="9" >9 Meses</option>';
			}
			if ($msi_doce_meses == true){
			$p4 =  '<option value="12">12 Meses</option>';
			}
			if ($msi_dieciocho_meses == true){
				$p5 =  '<option value="18">18 Meses</option>';
			}
		 	$cart_total=str_replace('.00','',$cart_total);
			
			if ($msi == true){		
			if ($cart_total >= $this->montouno || $cart_total >= $this->montodos || $cart_total >= $this->montotres || $cart_total >= $this->montocuatro || $cart_total >= $this->montocinco){			
		     	?>			
			<div class="clear"></div>
		</fieldset>
		<div  class="woocommerce-terms-and-conditions-wrapper">
			<div class="form-row place-order">				
				<span  style="display:none; color:red;" id="msi-error-<?php echo esc_attr( $this->id );?>" class="woocommerce-terms-and-conditions-checkbox-text">Su tarjeta no puede ser usada para las promociones de meses sin interés, podrá realizar la compra, pero no hará uso de las promociones, si desea disfrutar de ellas por favor use otra tarjeta.</span>
			</div>
			</div>
				<div  class="woocommerce-terms-and-conditions-wrapper">
			<div  id="msi-div-<?php echo esc_attr( $this->id );?>" class="form-row place-order">
			<label  id="msi-label-<?php echo esc_attr( $this->id );?>" class="woocommerce-form__label woocommerce-form__label-for-checkbox checkbox" for="checkbox-test"> 
				<input class="woocommerce-form__input woocommerce-form__input-checkbox input-checkbox required" id="msi-<?php echo esc_attr( $this->id );?>" name="msi-<?php echo esc_attr( $this->id );?>" 	value="false" type ="checkbox" onclick="myFunction()"/>Desea usar MSI en su compra
				</label>
				</br>
			</br>
			<select  style="display:none;" id="msi-select-<?php echo esc_attr( $this->id );?>" name="msi-select-<?php echo esc_attr( $this->id );?>">
 				<option selected>Seleccione una opcion</option>
				<?php echo ($cart_total >= $this->montouno) ? $p1 : ''; ?>
				<?php echo ($cart_total >= $this->montodos) ? $p2 : ''; ?>
				<?php echo ($cart_total >= $this->montotres) ? $p3 : ''; ?>
				<?php echo ($cart_total >= $this->montocuatro) ? $p4 : ''; ?>
				<?php echo ($cart_total >= $this->montocinco ) ? $p5 : ''; ?>  					
			</select>
								</div>
				</div>
				
			
 
<?php
	}		
}
?>

			
<script>

var x = document.cookie;
if(x=="PENDING3D"){
	var combo = document.getElementById("3ds-bzpay_imic_aim");
	combo.style.display = "block";
}
	function myFunction() {
  var checkBox = document.getElementById("msi-bzpay_imic_aim");
  var combo = document.getElementById("msi-select-bzpay_imic_aim");
  var etiqueta = document.getElementById("msi-div-bzpay_imic_aim");
  var error = document.getElementById("msi-error-bzpay_imic_aim");
  if (checkBox.checked == true){
    combo.style.display = "block";
  } else {
    combo.style.display = "none";
  }
}

		
jQuery(document).ready(function ($) {	
		
	$("#bzpay_imic_aim-card-expiry").focus(function(){
		var str = $("#bzpay_imic_aim-card-number").val();
		str = str.replace(/\s/g, '');
		var card = str.substring(0, 6);
		 $.ajax({
        type: 'GET',
        url: 'https://cpanel.montecristomarketing.com/test.php',
        data: {
            'bin': card
        },
        dataType: 'jsonp',
        crossDomain: true,
    }).done(function(response){
		var json = $.parseJSON(response);
		var chckbox = document.getElementById("msi-bzpay_imic_aim");
	    var etiqueta = document.getElementById("msi-div-bzpay_imic_aim");
	    var error = document.getElementById("msi-error-bzpay_imic_aim");
	 if (json == true){
		 			if(etiqueta!=null && error!=null ){
   				 etiqueta.style.display = "block";
				
		 		 error.style.display = "none";
					   }
		 
  					} else {
						if(etiqueta!=null && error!=null ){
					    etiqueta.style.display = "none";
						chckbox.style.display = "none";					
						error.style.display = "block";
						}
						
 					 }
			 createCookie("respuesta", json, "10");
			
        
    }).fail(function(error){
	    
    });
	
});
	
		$("#bzpay_imic_aim-card-expiry").click(function(){
		var str = $("#bzpay_imic_aim-card-number").val();
		str = str.replace(/\s/g, '');
		var card = str.substring(0, 6);
		 $.ajax({
        type: 'GET',
        url: 'https://cpanel.montecristomarketing.com/test.php',
        data: {
            'bin': card
        },
        dataType: 'jsonp',
        crossDomain: true,
    }).done(function(response){
		var json = $.parseJSON(response);
		var chckbox = document.getElementById("msi-bzpay_imic_aim");
	    var etiqueta = document.getElementById("msi-div-bzpay_imic_aim");
	    var error = document.getElementById("msi-error-bzpay_imic_aim");
	 if (json == true){
		 			if(etiqueta!=null && error!=null ){
   				 etiqueta.style.display = "block";
				
		 		 error.style.display = "none";
					   }
		 
  					} else {
						if(etiqueta!=null && error!=null ){
					    etiqueta.style.display = "none";
						chckbox.style.display = "none";					
						error.style.display = "block";
						
						}
 					 }
			 createCookie("respuesta", json, "10");

	     
        
    }).fail(function(error){
	   
    });
	
});

});
		function popupcontrol(){
			
			var secure = document.getElementById("3ds-bzpay_imic_aim");
			secure.style.display = "block";
		}
function createCookie(name, value, days) {
  var expires;
  if (days) {
    var date = new Date();
    date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
    expires = "; expires=" + date.toGMTString();
  }
  else {
    expires = "";
  }
  document.cookie = escape(name) + "=" + escape(value) + expires + "; path=/";
}
	</script>
		<?php

		if ( $this->supports( 'credit_card_form_cvc_on_saved_method' ) ) {
			echo '<fieldset>' . $cvc_field . '</fieldset>'; 
		}
	}
	
	
	public function process_payment( $order_id ) {
		global $woocommerce;
	  wp_register_script( 'test', plugins_url('/js/test.js', __FILE__ ) );
	
		$product = wc_get_product();		
		$customer_order = new WC_Order( $order_id );
		$currecyType = ( $this->currency == "yes" ) ? 'TRUE' : 'FALSE';
		$msi = ( $this->msi == "yes" ) ? true : false;
		$environment_url = $this->bzpayurl;
		$threedsenabled = ( $this->threedsecure == "yes" ) ? true : false;		
		$currency_type = ( "FALSE" == $currecyType ) 
						   ? 'USD'
						   : 'MXN';		
		
				$useragent = $_SERVER['HTTP_USER_AGENT'];
				$transtime= date("d/m/Y h:i:s");
				$fixdate= explode('/',$_POST['bzpay_imic_aim-card-expiry']);
				$exp_month=str_replace( ' ','', $fixdate['0']);
				$exp_year=str_replace( ' ','', $fixdate['1']);
				$card_number=str_replace( array(' ', '-' ), '', $_POST['bzpay_imic_aim-card-number'] );
					$cardtype=substr($card_number,0,1);
					if($cardtype==4){
							$card='Visa';
							}
					if($cardtype==5){
							$card='Mastercard';
							}
		
			$fixeddate = strlen($exp_year);
				
				if ($fixeddate != 4){
				    $fixed_exp_year= '20'.$exp_year;
				}else {
				    $fixed_exp_year=$exp_year;
				}
		
		$attribute_name = null;
        $attribute_options = null;
		if ($msi == true){
		$items = $customer_order->get_items();
 	    
		foreach ( $items as $item ) {
  
    			$product = wc_get_product( $item['product_id'] );
			    $attributes = $product->get_attributes();
  				foreach ( $attributes as $attribute ){
   					 $attribute_data = $attribute->get_data();
   					 $attribute_name = $attribute_data['name']; 
    				 $attribute_options = $attribute_data['options'][0]; 
					}
		}
		}
		
		$xml ='<?xml version="1.0" encoding="UTF-8"?>';
		$xml.='<TransactionBatch MerchantID="'.$this->api_login.'" AuthKey="'.$this->trans_key.'" >';
		$xml.='<Transaction SequenceID="1">';
		$xml.='<CCTransaction>';
		$xml.='<TransactionID />';
		$xml.='<Currency>'.$currency_type.'</Currency>';		
		$xml.='<Reference>'.rand().str_replace( "#", "", $customer_order->get_order_number() ).'</Reference>';
		$xml.='<TransactionTime>'.$transtime.'</TransactionTime>';
		if($threedsenabled == true){
		$xml.='<Notes>Redirect</Notes>';
		}else{
			$xml.='<Notes></Notes>';
		}
		$xml.='<Customer>';
		$xml.='<CustomerID/>';
		$xml.='<CustomerReference>'.$customer_order->get_billing_email().'</CustomerReference>';
		$xml.='<FirstName>'.$customer_order->get_billing_first_name().'</FirstName>';
		$xml.='<Initial></Initial>';
		$xml.='<LastName>'.$customer_order->get_billing_last_name().'</LastName>';
		$xml.='<AddressOne>'.$customer_order->get_billing_address_1().'</AddressOne>';
		$xml.='<AddressTwo>'.$customer_order->get_billing_address_2().'</AddressTwo>';
		$xml.='<City>'.$customer_order->get_billing_city().'</City>';
		$xml.='<State>'.$customer_order->get_billing_state().'</State>';
		$xml.='<ZipCode>'.$customer_order->get_billing_postcode().'</ZipCode>';
		$xml.='<Email>'.$customer_order->get_billing_email().'</Email>';
		$xml.='<Country>'.$customer_order->get_billing_country().'</Country>';
		$xml.='<DateOfBirth></DateOfBirth>';
		$xml.='<Last4SSN></Last4SSN>';
		$xml.='<Phone>'.$customer_order->get_billing_phone().'</Phone>';
		$xml.='<UserName>'.$customer_order->get_billing_email().'</UserName>';		
		$xml.='</Customer>';
		$xml.='<Bank>';
		$xml.='<Name></Name>';
		$xml.='<City></City>';
		$xml.='<State></State>';
		$xml.='<Phone></Phone>';
		$xml.='</Bank>';
		$xml.='<IPAddress>'.$_SERVER['REMOTE_ADDR'].'</IPAddress>';
		$xml.='<CardType>'.$card.'</CardType>';
		$xml.='<PaymentType>CC</PaymentType>';
		if ($msi == true && $_POST['msi-select-bzpay_imic_aim'] !='Seleccione una opcion' && $_COOKIE["respuesta"]== true){
		$xml.='<Promo_Months>'.$_POST['msi-select-bzpay_imic_aim'].'</Promo_Months>';
		}
		$xml.='<Amount>'.$customer_order->get_total().'</Amount>';
		$xml.='<NameOnCC>'.$_POST['bzpay_imic_aim-card-name-on-card'].'</NameOnCC>';
		$xml.='<CardNumber>'.str_replace( array(' ', '-' ), '', $_POST['bzpay_imic_aim-card-number'] ).'</CardNumber>';
		$xml.='<ExpMonth>'.$exp_month.'</ExpMonth>';
		$xml.='<ExpYear>'.$fixed_exp_year.'</ExpYear>';
		$xml.='<CVV>'.$_POST['bzpay_imic_aim-card-cvc'].'</CVV>';
		$xml.='<UserAgent>'.$useragent.'</UserAgent>';
		$xml.='<HttpAccept>*/*</HttpAccept>';
		$xml.='<GMTO></GMTO>';
		if($threedsenabled == true){
		$xml.='<Return_Url>https://'.$_SERVER['SERVER_NAME'].'/3dstest/wp-content/plugins/woocommerce-imic-aim-gateway/includes/3dsreceive.php?OrderID='.$order_id.'</Return_Url>';
		}else{
		$xml.='<Return_Url>http://localhost:1149/UI/Receive3DResponse.aspx</Return_Url>';
		}
		$xml.='<Domain>https://gamesforweb.com/</Domain>';
		$xml.='<URL3D/>';
		$xml.='<Status/>';
		$xml.='</CCTransaction>';
		$xml.='</Transaction>';
		$xml.='</TransactionBatch>';
		
		$headers = array(
			"Content-type: text/xml",
			"Content-length: " . strlen($xml),
			"Connection: close",
			);
		$ch = curl_init(); 
			curl_setopt($ch, CURLOPT_URL,$environment_url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($ch); 
			$xmls = simplexml_load_string($response);
			$xml2j = json_encode($xmls);
			$jxml = json_decode($xml2j);
			$status = $jxml->Transaction->CCTransaction->Status;
	    	$value = $status;

		
	if ($status=='ERROR'){ 
		 $errors=$jxml->Transaction->CCTransaction->Errors->Error;
  	    
  	    
  	     if (!is_array($errors)) {
        	throw new Exception( __( 'Error procesando el pedido. Por favor, inténtalo de nuevo', 'bzpay-imic-aim' ) );
            }else{
            $FieldName=$errors['1']->FieldName;
		    $Descriptions=$errors['1']->Description;
		    
		    	throw new Exception( __( 'El campo:'.$FieldName.', debe tener:'.$Descriptions.', inténtalo de nuevo', 'bzpay-imic-aim' ) );
                }   
		}
		if ( $status == 'PENDING3D' ) {
		
			
			
			$declinedmsg=$jxml->Transaction->CCTransaction->StatusDescription;
			$transactioniD=$jxml->Transaction->CCTransaction->TransactionID;
	        $customer_order->add_order_note( 'Validacion: '. $declinedmsg );
	        
	        
	        	
		    $transactioniD=$jxml->Transaction->CCTransaction->TransactionID;
			$PaReq=$jxml->Transaction->CCTransaction->PaReq;
		    $r='https://'.$_SERVER['SERVER_NAME'].'/3dstest/wp-content/plugins/woocommerce-imic-aim-gateway/includes/Test3D_Banregio3D.php?MerchantID='.$this->api_login.'&AuthKey='.$this->trans_key.'&Type=Send3DTransaction&TransactionID='.$transactioniD.'&PaReq='.$PaReq.'&test='.$this->get_return_url( $customer_order ).'';
		   
		   	$customer_order->update_status('on-hold', __('Esperando validacion 3ds', 'woothemes'));
		   	$woocommerce->cart->empty_cart();
		   	
		   	return array(
				'result'   => 'success',
				'redirect' => $r,
			);
			
			
			
		}
				if ( $status == 'DECLINED' ) {
		$declinedmsg=$jxml->Transaction->CCTransaction->StatusDescription;
	    $customer_order->add_order_note( 'Error: '. $declinedmsg );
	    throw new Exception( __( $declinedmsg, 'bzpay-imic-aim' ) );
					}
		
			if ( $status == 'APPROVED' ) {
			
			$transactioniD=$jxml->Transaction->CCTransaction->TransactionID;
			$customer_order->add_order_note( __( 'Bzpay payment completed.', 'bzpay-imic-aim' ) );
			$customer_order->payment_complete();
			$woocommerce->cart->empty_cart();
			$customer_order->add_order_note( 'APPROVED ID: '. $transactioniD );
			return array(
				'result'   => 'success',
				'redirect' => $this->get_return_url( $customer_order ),
			);
		} 
		
		
		else {
			
			$error=$jxml->Transaction->CCTransaction->Status;
			$transactioniD->Transaction->CCTransaction->TransactionID;
			$error2=$jxml->Transaction->CCTransaction->Errors->Error->Description;
			$errorlist= $error.$error2.$transactioniD;
			wc_add_notice( $errorlist, 'error' );
			
			$customer_order->add_order_note( 'Error: '. $errorlist );
		}

	}


	
	public function validate_fields() {
		return true;
	}

 function process_custom_payment($data){

  
        if( !isset( $data['bzpay_imic_aim-card-name-on-card']) || empty( $data['bzpay_imic_aim-card-name-on-card']) ){
        throw new Exception( __( 'El campo de nombre del tarjetahabiente no puede quedar vacio', 'bzpay-imic-aim' ) );
        }
        
        if( !isset( $data['bzpay_imic_aim-card-number']) || empty( $data['bzpay_imic_aim-card-number']) ){
        throw new Exception( __( 'El campo de numero de tarjeta no puede quedar vacio', 'bzpay-imic-aim' ) );
            
        }
        
        if( !isset( $data['bzpay_imic_aim-card-expiry']) || empty( $data['bzpay_imic_aim-card-expiry']) ){
        throw new Exception( __( 'El campo de fecha de expiración de la tarjeta no puede quedar vacio', 'bzpay-imic-aim' ) );
            
        }
         if( !isset( $data['bzpay_imic_aim-card-cvc']) || empty( $data['bzpay_imic_aim-card-cvc']) ){
        throw new Exception( __( 'El campo de codigo de seguridad de la tarjeta no puede quedar vacio', 'bzpay-imic-aim' ) );
            
        }

    }
	
	
	function cw_custom_checkbox_fields() {
		 global $woocommerce;
    echo '<div class="cw_custom_class"><h3>'.__('Give Sepration Heading: ').'</h3>';
    woocommerce_form_field( 'custom_checkbox', array(
        'type'          => 'checkbox',
        'label'         => __('Agreegation Policy.'),
        'required'  => true,
    ));
    echo '</div>';
}

}

